﻿Public Class Group

    Dim Number As Integer
    Dim Iro As String

    Dim X As Integer
    Dim Y As Integer



#Region "Public Sub New"
    Public Sub New(ByVal Number As Integer, ByVal Iro As String, ByVal X As Integer, ByVal Y As Integer)

        Me.Number = Number
        Me.Iro = Iro

        Me.X = X
        Me.Y = Y

    End Sub
#End Region



#Region "Public Sub Group_Form　⇒　群(Group)を作成する"
    Public Sub Group_Form(ByVal Grid As BoardGrid)
        Dim IsiLeft As Boolean = False
        Dim IsiRight As Boolean = False
        Dim IsiUp As Boolean = False
        Dim IsiDown As Boolean = False

        '▼左方向
        If X - 1 >= 0 Then
            If Grid.Cells(X - 1, Y).Status = Grid.Cells(X, Y).Status Then
                IsiLeft = True
                Call ArrayListGに記入(Number, Iro, X, Y, X - 1, Y)
            End If
        End If
        '▼右方向
        If X + 1 <= 18 Then
            If Grid.Cells(X + 1, Y).Status = Grid.Cells(X, Y).Status Then
                IsiRight = True
                Call ArrayListGに記入(Number, Iro, X, Y, X + 1, Y)
            End If
        End If
        '▼上方向
        If Y - 1 >= 0 Then
            If Grid.Cells(X, Y - 1).Status = Grid.Cells(X, Y).Status Then
                IsiUp = True
                Call ArrayListGに記入(Number, Iro, X, Y, X, Y - 1)
            End If
        End If
        '▼下方向
        If Y + 1 <= 18 Then
            If Grid.Cells(X, Y + 1).Status = Grid.Cells(X, Y).Status Then
                IsiDown = True
                Call ArrayListGに記入(Number, Iro, X, Y, X, Y + 1)
            End If
        End If

        If IsiLeft = True Or IsiRight = True Or IsiUp = True Or IsiDown = True Then

            '●++++++++++▼Groupに属する場合⇒(所属する群を調べ、その群に追加する)+++++++++++++++++●
            Call Groupの結合(ArrayListG)
            Call 重複文字の削除(ArrayListG)

        Else

            '●++++++++++▼初めての場合⇒(新しいGroupを作成する)+++++++++++++++++++++++++++++++++++●
            '▼空のArrayListGがあればそこに記入する
            For i As Integer = 0 To G_Kosu - 1
                If ArrayListG(i).Count = 0 Then
                    ArrayListG(i).Add(Number)
                    ArrayListG(i).Add(Iro)
                    ArrayListG(i).Add(X)
                    ArrayListG(i).Add(Y)

                    Exit Sub
                End If
            Next

            '▼ArrayListGが無ければ新しく作る
            ArrayListG(G_Kosu) = New ArrayList

            ArrayListG(G_Kosu).Add(Number)
            ArrayListG(G_Kosu).Add(Iro)
            ArrayListG(G_Kosu).Add(X)
            ArrayListG(G_Kosu).Add(Y)

            G_Kosu += 1
        End If

    End Sub


#Region "◆サブ⇒ArrayListGに記入◆"
    Private Sub ArrayListGに記入(ByVal Number As Integer, ByVal Iro As String, _
                                 ByVal X As Integer, ByVal Y As Integer, ByVal Xa As Integer, ByVal Yb As Integer)
        For i As Integer = 0 To G_Kosu - 1
            For j As Integer = 0 To ArrayListG(i).Count - 4 Step 4
                If CInt(ArrayListG(i)(j + 2)) = Xa And CInt(ArrayListG(i)(j + 3)) = Yb Then
                    ArrayListG(i).Add(Number)
                    ArrayListG(i).Add(Iro)
                    ArrayListG(i).Add(X)
                    ArrayListG(i).Add(Y)
                End If
            Next
        Next
    End Sub
#End Region


#Region "◆サブ⇒Groupの結合◆"
    Private Sub Groupの結合(ByVal ArrayListG() As ArrayList)
        '▼------------------------------ダブった群があれば結合する
trap:
        For i As Integer = 0 To G_Kosu - 1
            If ArrayListG(i).Count >= 4 Then
                For j As Integer = 0 To ArrayListG(i).Count - 4 Step 4
                    For m As Integer = i + 1 To G_Kosu - 1
                        For n As Integer = 0 To CInt(ArrayListG(m).Count) - 4 Step 4

                            If CStr(ArrayListG(i)(j + 1)) = CStr(ArrayListG(m)(n + 1)) And _
                               CInt(ArrayListG(i)(j + 2)) = CInt(ArrayListG(m)(n + 2)) And _
                               CInt(ArrayListG(i)(j + 3)) = CInt(ArrayListG(m)(n + 3)) Then

                                ArrayListG(i).AddRange(ArrayListG(m)) 'ダブった群を結合する
                                ArrayListG(m).Clear()
                                ArrayListG(m).TrimToSize()

                                GoTo trap                             '結合した場合はまた始めからやり直す
                            End If

                        Next n
                    Next m
                Next j
            End If
        Next i
    End Sub
#End Region


#Region "◆サブ⇒重複文字の削除◆"
    Private Sub 重複文字の削除(ByVal ArrayListG() As ArrayList)
        '▼------------------------------重複文字は削除する
trap:
        For i As Integer = 0 To G_Kosu - 1
            If ArrayListG(i).Count >= 8 Then
                For j As Integer = 0 To ArrayListG(i).Count - 8 Step 4
                    For k As Integer = j + 4 To ArrayListG(i).Count - 4 Step 4

                        If CStr(ArrayListG(i)(j + 1)) = CStr(ArrayListG(i)(k + 1)) And _
                           CInt(ArrayListG(i)(j + 2)) = CInt(ArrayListG(i)(k + 2)) And _
                           CInt(ArrayListG(i)(j + 3)) = CInt(ArrayListG(i)(k + 3)) Then

                            ArrayListG(i).RemoveRange(k, 4) '重複文字を削除する
                            ArrayListG(i).TrimToSize()

                            GoTo trap                       '削除した場合は初めからやり直す
                        End If

                    Next k
                Next j
            End If
        Next i
    End Sub
#End Region





#End Region



#Region "Public Sub Enclose_Ishi　⇒　囲まれた石を抽出し、その石を消す"
    Public Sub Enclose_Ishi(ByVal Grid As BoardGrid)
        Dim GroupCount As Integer = 0      '囲まれたGroupの数
        Dim GroupIndex(4) As Integer       '囲まれたGroupのArrayListGのIndex

        For i As Integer = 0 To 4
            GroupIndex(i) = 0
        Next
        '●+++++++++++++++今、石を置いたことで囲まれたGroup(石)がいくつあるか、又そのGroupのIndexは+++++++++++++++●
        For i = 0 To G_Kosu - 1       'すべてのGroup(群)アライリストをチェックする
            If LeftCheck(Grid, i) = True And RightCheck(Grid, i) = True And UpCheck(Grid, i) = True And DownCheck(Grid, i) = True Then
                '▼囲まれたGroupの数
                GroupCount += 1

                '▼囲まれたGroupのArrayListGのINdex(名前)
                If GroupCount = 1 Then GroupIndex(0) = i
                If GroupCount = 2 Then GroupIndex(1) = i
                If GroupCount = 3 Then GroupIndex(2) = i
                If GroupCount = 4 Then GroupIndex(3) = i
                If GroupCount = 5 Then GroupIndex(4) = i '理論上５つ以上は無い(今置いた石を含めて)
            End If
        Next

        '●++++++++++++++++++++++++++++++++++++++++++囲まれたGroup(石)を消す+++++++++++++++++++++++++++++++++++++++●
        Select Case GroupCount
            Case 0       '▼-----囲まれたGroup(石)が無い場合------▼
                Kou = False '劫ではない
                Exit Sub

            Case 1       '▼-----囲まれたGroup(石)が1つの場合-----▼
                Kou = False

                If Iro = ArrayListG(GroupIndex(0))(1) Then '囲まれたGroup(石)が今置いた石の場合(そこには置けない)
                    Call 石を置けない(Grid)

                    Exit Sub
                End If

                Call 石を消す(Grid, GroupIndex(0))

            Case 2      '▼-----囲まれたGroup(石)が2つの場合(劫の可能性あり)-----▼
                If ArrayListG(GroupIndex(0)).Count = 4 And ArrayListG(GroupIndex(1)).Count = 4 Then '囲まれたGroup(石)が2つで、石が1つづつの場合は劫である
                    If Kou = True Then '----------------------------劫の場合
                        Kou = True '劫を確認

                        Call 石を置けない(Grid)
                        MsgBox("「劫」 です。すぐには、取れません。別の場所に打ってから取って下さい。 ")

                        Exit Sub

                    ElseIf Kou = False Then '------------------------劫で無い場合 (囲まれたGroup(石)を消す)
                        Kou = True

                        For i = 0 To 1
                            Call 石を消す(Grid, GroupIndex(i))
                        Next
                    End If

                Else '-----------------------------------------------囲まれたGroupが2つだが、石が2個以上の場合(劫ではない)
                    Kou = False

                    For i = 0 To 1
                        Call 石を消す(Grid, GroupIndex(i))
                    Next

                End If


            Case 3 To 5 '▼-----囲まれたGroup(石)が3つ以上の場合-----▼
                Kou = False

                For i = 0 To GroupCount - 1
                    Call 石を消す(Grid, GroupIndex(i))
                Next

        End Select
    End Sub



#Region "◆石を置けない◆"
    Private Sub 石を置けない(ByVal Grid As BoardGrid)
        Call 石のクリヤー(Grid)

        '------------------ArrayList1の最後から４文字を削除
        ArrayList1.RemoveRange(ArrayList1.Count - 4, 4)
        ArrayList1.TrimToSize()

        '------------------置碁の場合は石を置き直す
        If Okigo = True Then
            Dim Hdc As Handicap = New Handicap(OkigoMoku)
            Hdc.Mokusu(Grid)
            Label0(1).Text = Hdc.MyLabel1
            Label0(2).Text = Hdc.MyLabel2
        End If

        '-------------------ArrayList1のデータ通り石と手順番号を再描画する
        For j As Integer = 0 To ArrayList1.Count - 4 Step 4
            Call 石と手順番号を描画(Grid, CInt(ArrayList1(j)), CStr(ArrayList1(j + 1)), _
                                          CInt(ArrayList1(j + 2)), CInt(ArrayList1(j + 3)))
        Next

        If Kou = True Then Exit Sub
        '---------------------MsgBoxを表示
        If Iro = "Black" Then
            MsgBox("ここに、 「黒 石」 を 置くことは出来ません。!!!")
        ElseIf Iro = "White" Then
            MsgBox("ここに、 「白 石」 を 置くことは出来ません。!!!")
        End If
    End Sub
#End Region

#Region "◆石を消す◆"
    Private Sub 石を消す(ByVal Grid As BoardGrid, ByVal GroupIndex As Integer)

        For j As Integer = 0 To ArrayListG(GroupIndex).Count - 4 Step 4 '囲まれたGroup(石)が今置いた石の場合(消してはいけない)
            If Iro = ArrayListG(GroupIndex)(j + 1) Then
                Exit Sub
            End If
        Next

        For j As Integer = 0 To ArrayListG(GroupIndex).Count - 4 Step 4
            Grid.Cells(CInt(ArrayListG(GroupIndex)(j + 2)), CInt(ArrayListG(GroupIndex)(j + 3))).Status = CellStatus.Nothing
            PictureBox1.Invalidate() '石を消す
        Next

        ArrayListG(GroupIndex).Clear()
        ArrayListG(GroupIndex).TrimToSize()

    End Sub
#End Region

#Region "◇左方向のチェック◇"
    Private Function LeftCheck(ByVal Grid As BoardGrid, ByVal i As Integer) As Boolean
        Dim IsiLeft As Boolean

        If ArrayListG(i).Count = 0 Then
            IsiLeft = False
            Return IsiLeft
            Exit Function
        End If


        For j As Integer = 0 To ArrayListG(i).Count - 4 Step 4
            Dim X As Integer = ArrayListG(i)(j + 2)
            Dim Y As Integer = ArrayListG(i)(j + 3)

            '▼自分と相手の色を取得(自分が黒ならば相手は白、白ならば黒)
            Dim MyStatus As CellStatus
            Dim AnotherStatus As CellStatus
            MyStatus = Grid.Cells(X, Y).Status
            If MyStatus = CellStatus.Black Then
                AnotherStatus = CellStatus.White
            Else
                AnotherStatus = CellStatus.Black
            End If

            '▼左方向のチェック
            For k As Integer = X - 1 To -1 Step -1
                If k < 0 Then
                    IsiLeft = True     '左が枠外の場合は異なる色と同じ
                    Exit For
                End If

                Select Case Grid.Cells(k, Y).Status
                    Case MyStatus
                        Exit Select    '左が同じ色の場合はまたその左をチェック
                    Case AnotherStatus
                        IsiLeft = True
                        Exit For       '左が異なる色の場合は囲まれている可能性あり、次に右方向をチェック
                    Case CellStatus.Nothing
                        IsiLeft = False
                        GoTo trap      '左が空の場合は終了
                End Select
            Next
        Next
trap:
        Return IsiLeft
    End Function
#End Region

#Region "◇右方向のチェック◇"
    Private Function RightCheck(ByVal Grid As BoardGrid, ByVal i As Integer) As Boolean
        Dim IsiRight As Boolean

        If ArrayListG(i).Count = 0 Then
            IsiRight = False
            Return IsiRight
            Exit Function
        End If

        For j As Integer = 0 To ArrayListG(i).Count - 4 Step 4
            Dim X As Integer = ArrayListG(i)(j + 2)
            Dim Y As Integer = ArrayListG(i)(j + 3)

            '▼自分と相手の色を取得(自分が黒ならば相手は白、白ならば黒)
            Dim MyStatus As CellStatus
            Dim AnotherStatus As CellStatus
            MyStatus = Grid.Cells(X, Y).Status
            If MyStatus = CellStatus.Black Then
                AnotherStatus = CellStatus.White
            Else
                AnotherStatus = CellStatus.Black
            End If

            '▼右方向のチェック
            For k As Integer = X + 1 To 19
                If k > 18 Then
                    IsiRight = True '右が枠外の場合は異なる色と同じ
                    Exit For
                End If

                Select Case Grid.Cells(k, Y).Status
                    Case MyStatus
                        Exit Select '右が同じ色の場合はまたその右をチェック
                    Case AnotherStatus
                        IsiRight = True
                        Exit For    '右が異なる色の場合は囲まれている可能性あり
                    Case CellStatus.Nothing
                        IsiRight = False
                        GoTo trap   '右が空の場合は終了
                End Select
            Next
        Next
trap:
        Return IsiRight
    End Function
#End Region

#Region "◇上方向のチェック◇"
    Private Function UpCheck(ByVal Grid As BoardGrid, ByVal i As Integer) As Boolean
        Dim IsiUp As Boolean

        If ArrayListG(i).Count = 0 Then
            IsiUp = False
            Return IsiUp
            Exit Function
        End If

        For j As Integer = 0 To ArrayListG(i).Count - 4 Step 4
            Dim X As Integer = ArrayListG(i)(j + 2)
            Dim Y As Integer = ArrayListG(i)(j + 3)

            '▼自分と相手の色を取得(自分が黒ならば相手は白、白ならば黒)
            Dim MyStatus As CellStatus
            Dim AnotherStatus As CellStatus

            MyStatus = Grid.Cells(X, Y).Status
            If MyStatus = CellStatus.Black Then
                AnotherStatus = CellStatus.White
            Else
                AnotherStatus = CellStatus.Black
            End If

            '▼上方向のチェック
            For k As Integer = Y - 1 To -1 Step -1
                If k < 0 Then
                    IsiUp = True        '上が枠外の場合は異なる色と同じ
                    Exit For
                End If

                Select Case Grid.Cells(X, k).Status
                    Case MyStatus
                        Exit Select     '上が同じ色の場合はまたその上をチェック
                    Case AnotherStatus
                        IsiUp = True
                        Exit For        '上が異なる色の場合は囲まれている可能性あり
                    Case CellStatus.Nothing
                        IsiUp = False
                        GoTo trap       '上が空の場合は終了
                End Select
            Next
        Next
trap:
        Return IsiUp

    End Function
#End Region

#Region "◇下方向のチェック◇"
    Private Function DownCheck(ByVal Grid As BoardGrid, ByVal i As Integer) As Boolean
        Dim IsiDown As Boolean

        If ArrayListG(i).Count = 0 Then
            IsiDown = False
            Return IsiDown
            Exit Function
        End If

        For j As Integer = 0 To ArrayListG(i).Count - 4 Step 4
            Dim X As Integer = ArrayListG(i)(j + 2)
            Dim Y As Integer = ArrayListG(i)(j + 3)

            '▼自分と相手の色を取得(自分が黒ならば相手は白、白ならば黒)
            Dim MyStatus As CellStatus
            Dim AnotherStatus As CellStatus
            MyStatus = Grid.Cells(X, Y).Status
            If MyStatus = CellStatus.Black Then
                AnotherStatus = CellStatus.White
            Else
                AnotherStatus = CellStatus.Black
            End If

            '▼下方向のチェック
            For k As Integer = Y + 1 To 19
                If k > 18 Then
                    IsiDown = True     '下が枠外の場合は異なる色と同じ
                    Exit For
                End If

                Select Case Grid.Cells(X, k).Status
                    Case MyStatus
                        Exit Select     '下が同じ色の場合はまたその下をチェック
                    Case AnotherStatus
                        IsiDown = True
                        Exit For        '下が異なる色の場合は囲まれている可能性あり
                    Case CellStatus.Nothing
                        IsiDown = False
                        GoTo trap       '下が空の場合は終了
                End Select
            Next
        Next
trap:
        Return IsiDown
    End Function
#End Region


#End Region



End Class
