﻿Public Class BoardControl
    '▼縦・横の数字のラベル
    Dim Label1L() As System.Windows.Forms.Label
    Dim Label2L() As System.Windows.Forms.Label

    '▼ピクチャーボックスの左・上の物理座標
    Dim X As Integer
    Dim Y As Integer

    '▼パネルの上からの物理座標(Y)
    Dim P1_YPoint As Integer
    Dim P2rc_YPoint As Integer
    Dim P2dc_YPoint As Integer
    Dim P2pc_YPoint As Integer
    Dim P3_YPoint As Integer

    '▼パネル1のテキストボックスのデータ1時退避場所
    Dim datap1(8) As String




#Region "Public Sub New"
    Public Sub New()

        X = 50 'ピクチャーボックスの左・上の物理座標
        Y = 65

        Select Case OrderName
            Case ""                    '起動時
                Call パネルの消去()
                P1_YPoint = Y + 150
                P3_YPoint = Y + 550

            Case "開く"
                Call パネルの消去()
                P1_YPoint = Y + 60
                P2rc_YPoint = Y + 250
                P2dc_YPoint = Y + 250
                P2pc_YPoint = Y + 250
                P3_YPoint = Y + 635

            Case "印刷"
                Call パネルの消去()
                P1_YPoint = Y + 60
                P2rc_YPoint = Y + 250
                P2dc_YPoint = Y + 250
                P2pc_YPoint = Y + 250
                P3_YPoint = Y + 635

            Case "上書き保存", "名前を付けて保存"
                Exit Sub
        End Select

        '▼標準の座標
        'P1_YPoint = Y + 60
        'P2rc_YPoint = Y + 250
        'P2dc_YPoint = Y + 250
        'P2pc_YPoint = Y + 250
        'P3_YPoint = Y + 635
    End Sub
#End Region


#Region "Base_Control　⇒　ベース(PictureBox等)のコントロール"
    Public Sub Base_Control()
        Call bcメニューの貼付()
        Call bcピクチャーボックスの貼付()
        Call bcローカルラベルの貼付()
        Call bcラベルの貼付()
    End Sub


#Region "bcメニューの貼付"
    Private Sub bcメニューの貼付()
        Form1.SuspendLayout()

        MenuStrip1 = New MenuStrip
        Item1 = New ToolStripMenuItem(19) {}
        Dim myItemText() As String = New String(19) _
                             {"ファイル(&F)", "開　く(&O)", "上書き保存(&S)", "名前を付けて保存(&A)", "印　　刷(&P)", _
                              "終　　了(&E)", "置　　碁(&R)", "互　　戦(&S)", "２　　子(&T)", "３　　子(&U)", "４　　子(&C)", _
                              "５　　子(&D)", "６　　子(&F)", "７　　子(&G)", "８　　子(&I)", "９　　子(&J)", "表　　示(&S)", _
                              "手順番号を表示する(&T)", "手順番号を表示しない(&U)", "ヘ ル プ(&H)"}
        For i As Integer = 0 To 5
            Item1(i) = New ToolStripMenuItem
            With Item1(i)
                .Text = myItemText(i)
                .Tag = i
                .Name = "メニュー" & i
            End With
            CType(Item1(i).DropDown, ToolStripDropDownMenu).ShowImageMargin = False     'メニュー文字列の前にできるイメージの余白
            CType(Item1(i).DropDown, ToolStripDropDownMenu).ShowCheckMargin = False     'メニュー文字列の前にできるチェックの余白
            AddHandler Item1(i).Click, AddressOf Form1.Item1_Click
        Next
        For i As Integer = 6 To Item1.Length - 1
            Item1(i) = New ToolStripMenuItem
            With Item1(i)
                .Text = myItemText(i)
                .Tag = i
                .Name = "メニュー" & i
            End With
            CType(Item1(i).DropDown, ToolStripDropDownMenu).ShowImageMargin = False     'メニュー文字列の前にできるイメージの余白
            CType(Item1(i).DropDown, ToolStripDropDownMenu).ShowCheckMargin = True      'メニュー文字列の前にできるチェックの余白
            AddHandler Item1(i).Click, AddressOf Form1.Item1_Click
        Next

        MenuStrip1.Items.Add(Item1(0))    'ファイル(&F)
        With Item1(0).DropDownItems
            .Add(Item1(1))                '開　  く(&O)
            .Add(New ToolStripSeparator)
            .Add(Item1(2))                '上書き保存(&S)
            .Add(Item1(3))                '名前を付けて保存(&A)
            .Add(New ToolStripSeparator)
            .Add(Item1(4))                '印  　刷(&P)
            .Add(New ToolStripSeparator)
            .Add(Item1(5))                '終　　了(&E)
        End With

        MenuStrip1.Items.Add(Item1(6))    '置　  碁(&R)
        With Item1(6).DropDownItems
            .Add(Item1(7))                '互　　戦(&S)
            .Add(New ToolStripSeparator)
            .Add(Item1(8))                '２　　子(&T)
            .Add(Item1(9))                '３　　子(&U)
            .Add(Item1(10))               '４　　子(&C)
            .Add(Item1(11))               '５　　子(&D)
            .Add(Item1(12))               '６　　子(&F)
            .Add(Item1(13))               '７　　子(&G)
            .Add(Item1(14))               '８　　子(&I)
            .Add(Item1(15))               '９　　子(&J)
        End With

        MenuStrip1.Items.Add(Item1(16))   '表　　示(&S)
        With Item1(16).DropDownItems
            .Add(Item1(17))               '手順番号を表示する(&T)
            .Add(Item1(18))               '手順番号を表示しない(&U)
        End With

        MenuStrip1.Items.Add(Item1(19))   'ヘ ル プ(&H)
        MenuStrip1.Dock = DockStyle.Top
        Form1.Controls.Add(MenuStrip1)

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "bcピクチャーボックスの貼付"
    Private Sub bcピクチャーボックスの貼付()
        Form1.SuspendLayout()

        PictureBox1 = New PictureBox
        With PictureBox1
            .Size = New Size(684, 684)
            .Location = New Point(X, Y)
            .BorderStyle = BorderStyle.None
            .SizeMode = PictureBoxSizeMode.StretchImage
            Try
                .Image = Image.FromFile(FPath & "My Data\boad.jpg")
            Catch ex As Exception
                .BackColor = Color.BlanchedAlmond
            End Try
        End With
        Form1.Controls.Add(PictureBox1)

        AddHandler PictureBox1.Paint, AddressOf Form1.PictureBox1_Paint
        AddHandler PictureBox1.MouseClick, AddressOf Form1.PictureBox1_MouseClick
        AddHandler PictureBox1.MouseMove, AddressOf Form1.PictureBox1_MouseMove
        AddHandler PictureBox1.MouseLeave, AddressOf Form1.PictureBox1_MouseLeave

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "bcローカルラベルの貼付"
    Private Sub bcローカルラベルの貼付()
        Form1.SuspendLayout()

        Label1L = New Label(18) {}
        Dim Label1LText() As String = New String(18) {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", _
                                                     "11", "12", "13", "14", "15", "16", "17", "18", "19"}
        For i As Integer = 0 To Label1L.Length - 1
            Label1L(i) = New Label
            With Label1L(i)
                .Size = New Size(30, 16)
                .Location = New Point(X + 5 + i * 36, Y - 16)
                .FlatStyle = FlatStyle.Flat
                .BackColor = Color.Transparent
                .ForeColor = Color.Black
                .Font = New Font("ＭＳ ゴシック", 11)
                .TextAlign = ContentAlignment.BottomCenter
                .Text = Label1LText(i)
            End With
            Form1.Controls.Add(Label1L(i))
        Next

        Label2L = New Label(18) {}
        Dim Label2LText() As String = New String(18) {"一", "二", " 三", "四", "五", "六", "七", "八", "九", "十", _
                                                     "十一", "十二", "十三", "十四", "十五", "十六", "十七", "十八", "十九"}
        For i As Integer = 0 To Label2L.Length - 1
            Label2L(i) = New Label
            With Label2L(i)
                .Size = New Size(36, 36)
                .Location = New Point(X - 35, Y + i * 36)
                .FlatStyle = FlatStyle.Flat
                .BackColor = Color.Transparent
                .ForeColor = Color.Black
                .Font = New Font("ＭＳ ゴシック", 9)
                .TextAlign = ContentAlignment.MiddleRight
                .Text = Label2LText(i)
            End With
            Form1.Controls.Add(Label2L(i))
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "bcラベルの貼付"
    Private Sub bcラベルの貼付()
        Form1.SuspendLayout()

        Label0 = New Label(3) {}
        Dim Label0Text() As String = New String(3) {"囲 碁 対 局 棋 譜 記 録", "互　　　　　戦", "(互　　　戦)", _
                              "★ 数字が赤色でアンダーラインのある石は、マウスの 「右ボタン」 クリックで 「取り消す」 ことが出来ます。"}
        For i As Integer = 0 To Label0.Length - 1
            Label0(i) = New Label

            With Label0(i)
                .FlatStyle = FlatStyle.Standard
                .BackColor = Color.Transparent
                .TextAlign = ContentAlignment.MiddleCenter
                .Text = Label0Text(i)
                Select Case i
                    Case 0 '----------------------------囲 碁 対 局 棋 譜 記 録
                        .Size = New Size(275, 30)
                        .Location = New Point(X + 686, Y) '735, 70)
                        .ForeColor = Color.Black
                        .Font = New Font("ＭＳ ゴシック", 14, FontStyle.Bold Or FontStyle.Underline)
                    Case 1 '----------------------------互　　　　　戦
                        .Size = New Size(684, 23)
                        .Location = New Point(X, Y - 40) '50, 25)
                        .ForeColor = Color.Red
                        .Font = New Font("ＭＳ ゴシック", 13)
                    Case 2 '----------------------------(互　　　戦)
                        .Size = New Size(275, 25)
                        .Location = New Point(X + 686, Y + 32) '735, 105)
                        .ForeColor = Color.Black
                        .Font = New Font("ＭＳ ゴシック", 12)
                    Case 3 '----------------------------★ 数字が赤色でアンダーラインのある石は、・・・・・
                        .Size = New Size(684, 20)
                        .Location = New Point(X, Y + 685) '50, 750)
                        .ForeColor = Color.Red
                        .Font = New Font("ＭＳ ゴシック", 9)
                End Select
            End With

            Form1.Controls.Add(Label0(i))
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region


#End Region


#Region "Panel1_Control　⇒　対局日、対局者氏名等のコントロール"
    Public Sub Panel1_Control()
        Call p1パネルの貼付()
        Call p1ラベルの貼付()
        Call p1テキストボックスの貼付()
        Call p1コンボボックスの貼付()

        TextBox1(0).Text = datap1(0)  '年
        TextBox1(1).Text = datap1(1)  '月
        TextBox1(2).Text = datap1(2)  '日
        TextBox1(3).Text = datap1(3)  '白　対局者名
        TextBox1(5).Text = datap1(4)  '白　段位または級位
        ComboBox1(0).Text = datap1(5) '白　段又は級
        TextBox1(4).Text = datap1(6)  '黒　対局者名
        TextBox1(6).Text = datap1(7)  '黒　段位または級位
        ComboBox1(1).Text = datap1(8) '黒　段又は級
    End Sub


#Region "p1パネルの貼付"
    Private Sub p1パネルの貼付()
        Form1.SuspendLayout()

        Panel1 = New Panel
        With Panel1
            .Size = New Size(275, 170)
            .Location = New Point(X + 686, P1_YPoint)
            .BackColor = Color.Transparent
        End With
        Form1.Controls.Add(Panel1)

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p1ラベルの貼付"
    Private Sub p1ラベルの貼付()
        Label1 = New Label(7) {}
        Dim Label1LText() As String = New String(7) {"<対局日>", "平成", "年", "月", "日", "<対局者氏名>", "白", "黒"}
        For i As Integer = 0 To Label1.Length - 1
            Label1(i) = New Label
            With Label1(i)
                .FlatStyle = FlatStyle.Standard
                .BackColor = Color.Transparent
                .ForeColor = Color.Black
                .Font = New Font("ＭＳ ゴシック", 11)
                .TextAlign = ContentAlignment.MiddleLeft
                .Text = Label1LText(i)
                Select Case i
                    Case 0 '-------------------------------<対局日>
                        .Size = New Size(115, 20)
                        .Location = New Point(10, 5)
                    Case 1 '-------------------------------平成
                        .Size = New Size(40, 20)
                        .Location = New Point(50, 30)
                    Case 2 '-------------------------------年
                        .Size = New Size(20, 20)
                        .Location = New Point(110, 30)
                    Case 3 '-------------------------------月
                        .Size = New Size(20, 20)
                        .Location = New Point(150, 30)
                    Case 4 '-------------------------------日
                        .Size = New Size(20, 20)
                        .Location = New Point(190, 30)
                    Case 5 '-------------------------------<対局者氏名>
                        .Size = New Size(110, 20)
                        .Location = New Point(10, 75)
                    Case 6 '-------------------------------白
                        .Size = New Size(20, 20)
                        .Location = New Point(40, 100)
                    Case 7 '-------------------------------黒
                        .Size = New Size(20, 20)
                        .Location = New Point(40, 130)
                End Select
            End With
            Panel1.Controls.Add(Label1(i))
        Next
    End Sub
#End Region

#Region "p1テキストボックスの貼付"
    Private Sub p1テキストボックスの貼付()
        Form1.SuspendLayout()

        TextBox1 = New TextBox(6) {}
        Dim Textbox1Text() As String = New String(6) {"", "", "", "", "", "", ""}
        For i As Integer = 0 To TextBox1.Length - 1
            TextBox1(i) = New TextBox
            With TextBox1(i)
                .BorderStyle = FlatStyle.Standard
                .BackColor = Color.White
                .ForeColor = Color.Blue
                .TextAlign = HorizontalAlignment.Center
                .Text = Textbox1Text(i)

                Select Case i
                    Case 0 To 2 '年月日
                        .Size = New Size(20, 18)
                        Select Case i
                            Case 0
                                .Location = New Point(90, 30)
                            Case 1
                                .Location = New Point(130, 30)
                            Case 2
                                .Location = New Point(170, 30)
                        End Select
                        .Font = New Font("ＭＳ ゴシック", 10)
                        .TabIndex = i
                    Case 3 To 4
                        With TextBox1(i) '氏名
                            .Size = New Size(100, 20)
                            .Font = New Font("ＭＳ ゴシック", 11)
                            Select Case i
                                Case 3
                                    .Location = New Point(70, 100)
                                    .TabIndex = 3
                                Case 4
                                    .Location = New Point(70, 130)
                                    .TabIndex = 6
                            End Select
                        End With
                    Case 5 To 6 '段級位
                        With TextBox1(i)
                            .Size = New Size(25, 20)
                            .Font = New Font("ＭＳ ゴシック", 11)
                            Select Case i
                                Case 5
                                    .Location = New Point(180, 100)
                                    .TabIndex = 4
                                Case 6
                                    .Location = New Point(180, 130)
                                    .TabIndex = 7
                            End Select
                        End With
                End Select
            End With
            Panel1.Controls.Add(TextBox1(i))
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p1コンボボックスの貼付"
    Private Sub p1コンボボックスの貼付()
        Form1.SuspendLayout()

        ComboBox1 = New ComboBox(1) {}
        Dim ComboBox1Text() As String = New String(5) {"級", "段", "人", "聖", "元", "因坊"}
        For i As Integer = 0 To ComboBox1.Length - 1
            ComboBox1(i) = New ComboBox
            With ComboBox1(i)
                .Size = New Size(40, 20)
                .BackColor = Color.White
                .ForeColor = Color.Blue
                .Font = New Font("ＭＳ ゴシック", 10.5)
                .Items.AddRange(ComboBox1Text)
                .DropDownStyle = ComboBoxStyle.DropDownList
                '.TabStop = False
                Select Case i
                    Case 0
                        .Location = New Point(205, 100)
                        .TabIndex = 5
                    Case 1
                        .Location = New Point(205, 130)
                        .TabIndex = 8
                End Select
            End With
            Panel1.Controls.Add(ComboBox1(i))
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region


#End Region


#Region "Panel2_RePlay_Contro　⇒　再生のコントロールl"
    Public Sub Panel2_RePlay_Control()
        Call p2_rcパネルの貼付()
        Call p2_rcグループボックスの貼付()
        Call p2_rcラベルの貼付()
        Call p2_rcボタンの貼付()
        Call p2_rcラジオボタンの貼付()
    End Sub


#Region "p2_rcパネルの貼付"
    Private Sub p2_rcパネルの貼付()
        Form1.SuspendLayout()

        Panel2 = New Panel
        With Panel2
            .Size = New Size(275, 434)
            .Location = New Point(X + 686, P2rc_YPoint)
            .BackColor = Color.Transparent
            '.AutoScroll = True
        End With
        Form1.Controls.Add(Panel2)

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_rcグループボックスの貼付"
    Private Sub p2_rcグループボックスの貼付()
        Form1.SuspendLayout()

        GroupBox1 = New System.Windows.Forms.GroupBox(1) {}
        Dim GroupBox1Text() As String = New String() {"自動再生", "手動再生"}
        For i As Integer = 0 To GroupBox1.Length - 1
            GroupBox1(i) = New System.Windows.Forms.GroupBox
            With GroupBox1(i)
                Select Case i
                    Case 0
                        .Size = New Size(200, 120)
                        .Location = New Point(38, 100)
                    Case 1
                        .Size = New Size(200, 90)
                        .Location = New Point(38, 240)
                End Select
                .ForeColor = Color.FromArgb(255, 165, 0)
                .BackColor = Color.Transparent
                .FlatStyle = FlatStyle.Flat
                .Font = New Font("", 12, FontStyle.Bold)
                .Text = GroupBox1Text(i)
            End With
            Panel2.Controls.Add(GroupBox1(i))
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_rcラベルの貼付"
    Private Sub p2_rcラベルの貼付()
        Form1.SuspendLayout()

        Label2 = New System.Windows.Forms.Label(2) {}
        Label2(2) = New System.Windows.Forms.Label
        For i As Integer = 0 To Label2.Length - 1
            Label2(i) = New System.Windows.Forms.Label
            With Label2(i)
                .BorderStyle = BorderStyle.None
                .BackColor = Color.Transparent
                .TextAlign = ContentAlignment.BottomLeft
                Select Case i
                    Case 0
                        .Size = New Size(Panel1.Width, 90)
                        .Location = New Point(0, 0)
                        .ForeColor = Color.Navy '.Red
                        .Font = New Font("ＭＳ ゴシック", 10.5, FontStyle.Bold)
                        .Text = ""
                        Panel2.Controls.Add(Label2(0))
                    Case 1
                        .Size = New Size(45, 10)
                        .Location = New Point(3, 35)
                        .ForeColor = Color.Maroon
                        .Font = New Font("ＭＳ ゴシック", 8)
                        .Text = "最初へ"
                        GroupBox1(1).Controls.Add(Label2(1))
                    Case 2
                        .Size = New Size(45, 10)
                        .Location = New Point(160, 35)
                        .ForeColor = Color.Maroon
                        .Font = New Font("ＭＳ ゴシック", 8)
                        .Text = "最後へ"
                        GroupBox1(1).Controls.Add(Label2(2))
                End Select
            End With
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_rcボタンの貼付"
    Private Sub p2_rcボタンの貼付()
        Form1.SuspendLayout()

        Button2 = New System.Windows.Forms.Button(6) {}
        Dim Button2Text() As String = New String(6) {"再　生", "中  止", "┃≪", "≪戻る", "進む≫", "≫┃", "再生終了"}
        For i As Integer = 0 To Button2.Length - 1
            Button2(i) = New System.Windows.Forms.Button
            With Button2(i)
                .Tag = i
                .TabStop = False
                .FlatStyle = FlatStyle.System
                Select Case i
                    Case 0
                        .Size = New Size(60, 20)
                        .Location = New Point(22, 35)
                        GroupBox1(0).Controls.Add(Button2(i))
                    Case 1
                        .Size = New Size(60, 20)
                        .Location = New Point(118, 35)
                        GroupBox1(0).Controls.Add(Button2(i))
                    Case 2
                        .Size = New Size(45, 23)
                        .Location = New Point(5, 45)
                        .FlatStyle = FlatStyle.Standard
                        GroupBox1(1).Controls.Add(Button2(i))
                    Case 3
                        .Size = New Size(50, 23)
                        .Location = New Point(5 + Button2(2).Width, 45)
                        .FlatStyle = FlatStyle.Standard
                        GroupBox1(1).Controls.Add(Button2(i))
                    Case 4
                        .Size = New Size(50, 23)
                        .Location = New Point(5 + Button2(2).Width + Button2(3).Width, 45)
                        .FlatStyle = FlatStyle.Standard
                        GroupBox1(1).Controls.Add(Button2(i))
                    Case 5
                        .Size = New Size(45, 23)
                        .Location = New Point(5 + Button2(2).Width + Button2(3).Width + Button2(4).Width, 45)
                        .FlatStyle = FlatStyle.Standard
                        GroupBox1(1).Controls.Add(Button2(i))
                    Case 6
                        .Size = New Size(70, 25)
                        .Location = New Point(102, 370)
                        Panel2.Controls.Add(Button2(i))
                End Select
                .Text = Button2Text(i)
                .Font = New Font("", 8)
                .ForeColor = Color.Black
                .BackColor = Color.White
            End With
            AddHandler Button2(i).Click, AddressOf Form1.Button2_Click
            AddHandler Button2(i).MouseEnter, AddressOf Form1.Button2_MouseEnter
            AddHandler Button2(i).MouseLeave, AddressOf Form1.Button2_MouseLeave
        Next
        Button2(1).Enabled = False

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_rcラジオボタンの貼付"
    Private Sub p2_rcラジオボタンの貼付()
        Form1.SuspendLayout()

        RadioButton1 = New System.Windows.Forms.RadioButton(2) {}
        Dim RadioButton1Text() As String = New String(2) {"早い", "中速", "遅い"}
        For i As Integer = 0 To RadioButton1.Length - 1
            RadioButton1(i) = New System.Windows.Forms.RadioButton
            With RadioButton1(i)
                .Text = RadioButton1Text(i)
                .CheckAlign = ContentAlignment.TopLeft
                .ForeColor = Color.Black
                .Font = New Font("", 8)
                Select Case i
                    Case 0
                        .Size = New Size(50, 20)
                        .Location = New Point(20, 80)
                    Case 1
                        .Size = New Size(50, 20)
                        .Location = New Point(80, 80)
                    Case 2
                        .Size = New Size(50, 20)
                        .Location = New Point(140, 80)
                End Select

            End With
            GroupBox1(0).Controls.Add(RadioButton1(i))
        Next
        RadioButton1(0).Checked = True

        Form1.ResumeLayout(False)
    End Sub
#End Region


#End Region


#Region "Panel2_Delete_Control　⇒　削除のコントロール"
    Public Sub Panel2_Delete_Control()
        Call p2_dcパネルの貼付()
        Call p2_dcラベルの貼付()
        Call p2_dcボタンの貼付()
    End Sub


#Region "p2_dcパネルの貼付"
    Private Sub p2_dcパネルの貼付()
        Form1.SuspendLayout()

        Panel2 = New Panel
        With Panel2
            .Size = New Size(275, 550) '434)
            .Location = New Point(X + 686, P2dc_YPoint)
            .BackColor = Color.Transparent
        End With
        Form1.Controls.Add(Panel2)

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_dcラベルの貼付"
    Private Sub p2_dcラベルの貼付()
        Form1.SuspendLayout()

        Label2 = New System.Windows.Forms.Label(0) {}
        Label2(0) = New System.Windows.Forms.Label
        With Label2(0)
            .Size = New Size(275, 57)
            .Location = New Point(0, 0)
            .FlatStyle = FlatStyle.Flat
            .BackColor = Color.Transparent
            .ForeColor = Color.Red
            .Font = New Font("ＭＳ ゴシック", 10.5, FontStyle.Bold)
            .TextAlign = ContentAlignment.TopLeft
            .Text = " ★ 登録した棋譜のファイルを削除し" & vbLf & "   ます。" & vbLf _
                  & "    削除したいファイルを選択し、削" & vbLf & "   除ボタンをクリックして下さい。"
        End With
        Panel2.Controls.Add(Label2(0))

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_dcボタンの貼付"
    Private Sub p2_dcボタンの貼付()
        Form1.SuspendLayout()

        Button2 = New System.Windows.Forms.Button(1) {}
        Dim Button2Text() As String = New String(1) {"削　　除", "終    了"}
        For i As Integer = 0 To Button2.Length - 1
            Button2(i) = New System.Windows.Forms.Button
            With Button2(i)
                .Tag = i
                .TabStop = False
                .Size = New Size(60, 25)
                Select Case i
                    Case 0
                        .Location = New Point(55, 520)
                    Case 1
                        .Location = New Point(155, 520)
                End Select
                .Text = Button2Text(i)
                .FlatStyle = FlatStyle.System
                .Font = New Font("", 8)
            End With
            Panel2.Controls.Add(Button2(i))
            AddHandler Button2(i).Click, AddressOf Form1.Button2_Click
        Next
        Button2(0).Enabled = False

        Form1.ResumeLayout(False)
    End Sub
#End Region


#End Region


#Region "Panel2_Print_Control　⇒　印刷のコントロール"
    Public Sub Panel2_Print_Control()
        Call p2_pcパネルの貼付()
        Call p2_pcラジオボタンの貼付()
        Call p2_pcラベルの貼付()
        Call p2_pcテキストポックスの貼付()
        Call p2_pcボタンの貼付()
    End Sub


#Region "p2_pcパネルの貼付"
    Private Sub p2_pcパネルの貼付()
        Form1.SuspendLayout()

        Panel2 = New Panel
        With Panel2
            .Size = New Size(275, 434)
            .Location = New Point(X + 686, P2pc_YPoint)
            .BackColor = Color.Transparent
        End With
        Form1.Controls.Add(Panel2)

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_pcラジオボタンの貼付"
    Private Sub p2_pcラジオボタンの貼付()
        Form1.SuspendLayout()

        RadioButton1 = New System.Windows.Forms.RadioButton(4) {}
        Dim RadioButton1Text() As String = New String(4) {"第１譜 印刷", "第２譜 印刷", "第３譜 印刷", "第４譜 印刷", "第５譜 印刷"}
        For i As Integer = 0 To RadioButton1.Length - 1
            RadioButton1(i) = New System.Windows.Forms.RadioButton
            With RadioButton1(i)
                .Tag = i
                .Size = New Size(100, 20)
                .Text = RadioButton1Text(i)
                .CheckAlign = ContentAlignment.MiddleLeft
                .BackColor = Color.Transparent
                .ForeColor = Color.Navy
                .Font = New Font("", 10)
                Select Case i
                    Case 0
                        .Location = New Point(10, 100)
                    Case 1
                        .Location = New Point(10, 150)
                    Case 2
                        .Location = New Point(10, 200)
                    Case 3
                        .Location = New Point(10, 250)
                    Case 4
                        .Location = New Point(10, 300)
                End Select

            End With
            Panel2.Controls.Add(RadioButton1(i))
            AddHandler RadioButton1(i).CheckedChanged, AddressOf Form1.RadioButton1_CheckedChanged
            RadioButton1(i).Enabled = False
        Next
        RadioButton1(0).Enabled = True

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_pcラベルの貼付"
    Private Sub p2_pcラベルの貼付()
        Form1.SuspendLayout()

        Dim a As Integer = 10   '貼付基準点(RadioButtom1(0))
        Dim b As Integer = 100

        Label2 = New System.Windows.Forms.Label(12) {}
        Dim Label2Text() As String = New String(12) {"★ 下記の棋譜を印刷します。", "", "", "手目～", "手目～", "手目～", _
                                                     "手目～", "手目～", "手目", "手目", "手目", "手目", "手目"}
        For i As Integer = 0 To Label2.Length - 1
            Label2(i) = New System.Windows.Forms.Label

            With Label2(i)
                .FlatStyle = FlatStyle.Standard '.Flat
                .BackColor = Color.Transparent
                .ForeColor = Color.Navy
                .Font = New Font("ＭＳ ゴシック", 10.5)
                .TextAlign = ContentAlignment.MiddleCenter '.MiddleLeft
                .Text = Label2Text(i)

                Select Case i
                    Case 0 '----------------------------------★ 下記の棋譜を印刷します。
                        .Size = New Size(275, 20)
                        .Location = New Point(0, 10)
                    Case 1 '-----------------------------------<ファイル名>
                        .Size = New Size(275, 25)
                        .Location = New Point(0, 15 + Label2(0).Height)
                        Try
                            .Text = System.IO.Path.GetFileNameWithoutExtension(Form1.OpenFileDialog1.FileName)
                        Catch ex As Exception
                            .Text = ""
                        End Try
                        .Font = New Font("ＭＳ ゴシック", 12, FontStyle.Bold)
                        .TextAlign = ContentAlignment.MiddleCenter
                        .ForeColor = Color.Red
                    Case 2 '-----------------------------------最終着手は<最終着手番号>手目です--
                        .Size = New Size(275, 20)
                        .Location = New Point(0, 30 + Label1(0).Height + Label1(1).Height)
                        .Text = "--最終着手は " & ArrayList1.Item(ArrayList1.Count - 4) & " 手目です--"
                        .ForeColor = Color.Red
                    Case 3 '-----------------------------------手目 ～
                        .Size = New Size(49, 20)
                        .Location = New Point(a + 45, b + RadioButton1(0).Height)
                    Case 4 '-----------------------------------手目 ～
                        .Size = New Size(49, 20)
                        .Location = New Point(a + 45, b + 50 + RadioButton1(1).Height)
                    Case 5 '-----------------------------------手目 ～
                        .Size = New Size(49, 20)
                        .Location = New Point(a + 45, b + 100 + RadioButton1(2).Height)
                    Case 6 '-----------------------------------手目 ～
                        .Size = New Size(49, 20)
                        .Location = New Point(a + 45, b + 150 + RadioButton1(3).Height)
                    Case 7 '-----------------------------------手目 ～
                        .Size = New Size(49, 20)
                        .Location = New Point(a + 45, b + 200 + RadioButton1(4).Height)

                    Case 8 '-----------------------------------手目
                        .Size = New Size(35, 20)
                        .Location = New Point(a + 119, b + RadioButton1(0).Height)
                    Case 9 '-----------------------------------手目
                        .Size = New Size(35, 20)
                        .Location = New Point(a + 119, b + 50 + RadioButton1(1).Height)
                    Case 10 '----------------------------------手目
                        .Size = New Size(35, 20)
                        .Location = New Point(a + 119, b + 100 + RadioButton1(2).Height)
                    Case 11 '----------------------------------手目
                        .Size = New Size(35, 20)
                        .Location = New Point(a + 119, b + 150 + RadioButton1(3).Height)
                    Case 12 '----------------------------------手目
                        .Size = New Size(35, 20)
                        .Location = New Point(a + 119, b + 200 + RadioButton1(4).Height)
                End Select

            End With
            Panel2.Controls.Add(Label2(i))
        Next

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_pcテキストポックスの貼付"
    Private Sub p2_pcテキストポックスの貼付()
        Form1.SuspendLayout()

        Dim a As Integer = 10   '貼付基準点(RadioButtom1(0))
        Dim b As Integer = 100

        TextBox2 = New System.Windows.Forms.TextBox(9) {}
        For i As Integer = 0 To TextBox2.Length - 1
            TextBox2(i) = New System.Windows.Forms.TextBox

            With TextBox2(i)
                .Tag = i
                .TabStop = True
                .Size = New Size(25, 10)
                .BorderStyle = FlatStyle.Standard '.Flat
                .BackColor = Color.White
                .ForeColor = Color.Red
                .Font = New Font("ＭＳ ゴシック", 9)
                .TextAlign = HorizontalAlignment.Center
                .Text = ""

                Select Case i
                    Case 0
                        .Location = New Point(a + 20, b + RadioButton1(0).Height)
                        .TabIndex = 0
                    Case 1
                        .Location = New Point(a + 20, b + 50 + RadioButton1(1).Height)
                        .TabIndex = 2
                    Case 2
                        .Location = New Point(a + 20, b + 100 + RadioButton1(2).Height)
                        .TabIndex = 4
                    Case 3
                        .Location = New Point(a + 20, b + 150 + RadioButton1(3).Height)
                        .TabIndex = 6
                    Case 4
                        .Location = New Point(a + 20, b + 200 + RadioButton1(4).Height)
                        .TabIndex = 8
                    Case 5
                        .Location = New Point(a + 94, b + RadioButton1(0).Height)
                        .TabIndex = 1
                    Case 6
                        .Location = New Point(a + 94, b + 50 + RadioButton1(1).Height)
                        .TabIndex = 3
                    Case 7
                        .Location = New Point(a + 94, b + 100 + RadioButton1(2).Height)
                        .TabIndex = 5
                    Case 8
                        .Location = New Point(a + 94, b + 150 + RadioButton1(3).Height)
                        .TabIndex = 7
                    Case 9
                        .Location = New Point(a + 94, b + 200 + RadioButton1(4).Height)
                        .TabIndex = 9
                End Select

            End With
            Panel2.Controls.Add(TextBox2(i))
            AddHandler TextBox2(i).KeyPress, AddressOf Form1.TextBox2_KeyPress
            'AddHandler TextBox2(i).Validating, AddressOf Form1.TextBox2_Validating
            TextBox2(i).Enabled = False
        Next
        TextBox2(0).Text = "1"

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p2_pcボタンの貼付"
    Private Sub p2_pcボタンの貼付()
        Form1.SuspendLayout()

        Dim a As Integer = 10   '貼付基準点(RadioButtom1(0))
        Dim b As Integer = 100

        Button2 = New System.Windows.Forms.Button(11) {}
        Dim Button2Text() As String = New String(11) {"表   示", "表   示", "表   示", "表   示", "表   示", _
                                                      "印 　刷", "印 　刷", "印 　刷", "印 　刷", "印 　刷", _
                                                      "印刷終了", " 印      刷    プレビュー"}
        For i As Integer = 0 To Button2.Length - 1
            Button2(i) = New System.Windows.Forms.Button
            With Button2(i)
                .Tag = i
                .TabStop = False
                .Size = New Size(45, 25)
                .Text = Button2Text(i)
                .FlatStyle = FlatStyle.System
                .Font = New Font("", 8)

                Select Case i
                    Case 0
                        .Location = New Point(a + 155, b + RadioButton1(0).Height - 3)
                    Case 1
                        .Location = New Point(a + 155, b + 50 + RadioButton1(1).Height - 3)
                    Case 2
                        .Location = New Point(a + 155, b + 100 + RadioButton1(2).Height - 3)
                    Case 3
                        .Location = New Point(a + 155, b + 150 + RadioButton1(3).Height - 3)
                    Case 4
                        .Location = New Point(a + 155, b + 200 + RadioButton1(4).Height - 3)
                    Case 5
                        .Location = New Point(a + 205, b + RadioButton1(0).Height - 3)
                    Case 6
                        .Location = New Point(a + 205, b + 50 + RadioButton1(1).Height - 3)
                    Case 7
                        .Location = New Point(a + 205, b + 100 + RadioButton1(2).Height - 3)
                    Case 8
                        .Location = New Point(a + 205, b + 150 + RadioButton1(3).Height - 3)
                    Case 9
                        .Location = New Point(a + 205, b + 200 + RadioButton1(4).Height - 3)
                    Case 10
                        .Size = New Size(60, 30)
                        .Location = New Point(50, 390)
                    Case 11
                        .Size = New Size(60, 30)
                        .Location = New Point(165, 390)
                End Select

            End With
            Panel2.Controls.Add(Button2(i))
            AddHandler Button2(i).Click, AddressOf Form1.Button2_Click

            Button2(i).Enabled = False
        Next
        Button2(10).Enabled = True

        Form1.ResumeLayout(False)
    End Sub
#End Region


#End Region


#Region "Panel3_Control　⇒　ベースのボタンコントロール"
    Public Sub Panel3_Control()

        Call p3パネルの貼付()
        Call p3ボタンの貼付()

    End Sub


#Region "p3パネルの貼付"
    Private Sub p3パネルの貼付()
        Form1.SuspendLayout()

        Panel3 = New Panel
        With Panel3
            .Size = New Size(275, 50)
            .Location = New Point(X + 686, P3_YPoint)
            .BackColor = Color.Transparent
            '.BackColor = Color.Maroon
            '.AutoScroll = True
        End With
        Form1.Controls.Add(Panel3)

        Form1.ResumeLayout(False)
    End Sub
#End Region

#Region "p3ボタンの貼付"
    Private Sub p3ボタンの貼付()
        Form1.SuspendLayout()

        Button1 = New Button(1) {}
        Dim Button1Text() As String = New String(1) {"終　 了", "　　画  　　面 　　全クリヤー"}
        For i As Integer = 0 To Button1.Length - 1
            Button1(i) = New Button
            With Button1(i)
                .Tag = i
                .TabStop = False
                .Size = New Size(80, 30)
                Select Case i
                    Case 0
                        .Location = New Point(38, 10)
                    Case 1
                        .Location = New Point(156, 10)
                End Select
                .Text = Button1Text(i)
                .FlatStyle = FlatStyle.System
                .Font = New Font("", 8)

            End With
            Panel3.Controls.Add(Button1(i))
            AddHandler Button1(i).Click, AddressOf Form1.Button1_Click
        Next
        Button1(1).Enabled = False

        Form1.ResumeLayout(False)
    End Sub
#End Region


#End Region


#Region "サブ⇒パネルの消去"
    Private Sub パネルの消去()
        '▼パネルを１度消去して再度表示し直す
        If Form1.Controls.Contains(Panel1) = True Then
            datap1(0) = TextBox1(0).Text  '年
            datap1(1) = TextBox1(1).Text  '月
            datap1(2) = TextBox1(2).Text  '日
            datap1(3) = TextBox1(3).Text  '白　対局者名
            datap1(4) = TextBox1(5).Text  '白　段位または級位
            datap1(5) = ComboBox1(0).Text '白　段又は級
            datap1(6) = TextBox1(4).Text  '黒　対局者名
            datap1(7) = TextBox1(6).Text  '黒　段位または級位
            datap1(8) = ComboBox1(1).Text '黒　段又は級

            Form1.Controls.Remove(Panel1)
        End If

        If Form1.Controls.Contains(Panel2) = True Then
            Form1.Controls.Remove(Panel2)
        End If
        If Form1.Controls.Contains(Panel3) = True Then
            Form1.Controls.Remove(Panel3)
        End If
    End Sub
#End Region





End Class
