﻿Public Class Handicap



    Dim Moku As Integer

    Dim X(8) As Integer
    Dim Y(8) As Integer

    Public _MyLabel1 As String
    Public _MyLabel2 As String



#Region "Public Sub New(ByVal Moku As Integer)"
    Public Sub New(ByVal Moku As Integer)
        '▼置石の目数を記録しておく
        OkigoMoku = Moku
        Me.Moku = Moku

        '▼置石を描画する場所の論理座標
        X(0) = 3 : X(1) = 9 : X(2) = 15 : X(3) = 3 : X(4) = 9 : X(5) = 15 : X(6) = 3 : X(7) = 9 : X(8) = 15
        Y(0) = 3 : Y(1) = 3 : Y(2) = 3 : Y(3) = 9 : Y(4) = 9 : Y(5) = 9 : Y(6) = 15 : Y(7) = 15 : Y(8) = 15
    End Sub
#End Region



#Region " Public Property MyLabel1"
    '----------------外部からアクセス可能とするプロパティ
    Public ReadOnly Property MyLabel1() As String
        Get
            Return _MyLabel1
        End Get
    End Property

    Public ReadOnly Property MyLabel2() As String
        Get
            Return _MyLabel2
        End Get
    End Property
#End Region



#Region "Public Sub Mokusu(ByVal Grid As Board)"
    Public Sub Mokusu(ByVal Grid As BoardGrid)
        Select Case Moku
            Case 1 '----------互戦
                Okigo = False
                OkigoMoku = 0
                _MyLabel1 = "互　　　　　戦"
                _MyLabel1 = "(互　　　戦)"

                Exit Sub
            Case 2 '----------2子局
                Okigo = True
                OkigoMoku = 2

                For i As Integer = 0 To 8
                    If i = 2 Or i = 6 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 3 '----------3子局
                Okigo = True
                OkigoMoku = 3

                For i As Integer = 0 To 8
                    If i = 2 Or i = 6 Or i = 8 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 4 '----------4子局
                Okigo = True
                OkigoMoku = 4

                For i As Integer = 0 To 8
                    If i = 0 Or i = 2 Or i = 6 Or i = 8 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 5 '----------5子局
                Okigo = True
                OkigoMoku = 5

                For i As Integer = 0 To 8
                    If i = 0 Or i = 2 Or i = 4 Or i = 6 Or i = 8 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 6 '----------6子局
                Okigo = True
                OkigoMoku = 6

                For i As Integer = 0 To 8
                    If i = 0 Or i = 2 Or i = 3 Or i = 5 Or i = 6 Or i = 8 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 7 '----------7子局
                Okigo = True
                OkigoMoku = 7

                For i As Integer = 0 To 8
                    If i = 0 Or i = 2 Or i = 3 Or i = 4 Or i = 5 Or i = 6 Or i = 8 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 8 '----------8子局
                Okigo = True
                OkigoMoku = 8

                For i As Integer = 0 To 8
                    If i = 0 Or i = 1 Or i = 2 Or i = 3 Or i = 5 Or i = 6 Or i = 7 Or i = 8 Then
                        Call 置石を描画する(Grid, i)
                    End If
                Next

            Case 9 '----------9子局
                Okigo = True
                OkigoMoku = 9

                For i As Integer = 0 To 8
                    Call 置石を描画する(Grid, i)
                Next
        End Select

        _MyLabel1 = OkigoMoku & " 子 局 戦"
        _MyLabel2 = "(" & OkigoMoku & " 子 局 戦)"
    End Sub


#Region "サブ⇒置石を描画する"
    Private Sub 置石を描画する(ByVal Grid As BoardGrid, ByVal i As Integer)
        '石を描く
        Grid.Cells(X(i), Y(i)).Status = CellStatus.Black
        PictureBox1.Invalidate()

        'グループを作成する
        Dim Groups As Group = New Group(OkigoMoku, "Black", X(i), Y(i))
        Groups.Group_Form(Grid)

    End Sub
#End Region


#End Region





End Class
