﻿Module Module1


    '▼データの保存場所のパス
    Public FPath As String = Left(My.Application.Info.DirectoryPath, _
                             InStrRev(My.Application.Info.DirectoryPath, _
                                      My.Application.Info.AssemblyName) + Len(My.Application.Info.AssemblyName))

    Public Panel1 As System.Windows.Forms.Panel
    Public Panel2 As System.Windows.Forms.Panel
    Public Panel3 As System.Windows.Forms.Panel
    Public MenuStrip1 As System.Windows.Forms.MenuStrip
    Public Item1() As System.Windows.Forms.ToolStripMenuItem
    Public PictureBox1 As System.Windows.Forms.PictureBox
    Public Label0() As System.Windows.Forms.Label
    Public Label1() As System.Windows.Forms.Label
    Public Label2() As System.Windows.Forms.Label
    Public TextBox1() As System.Windows.Forms.TextBox
    Public TextBox2() As System.Windows.Forms.TextBox
    Public ComboBox1() As System.Windows.Forms.ComboBox
    Public Button1() As System.Windows.Forms.Button
    Public Button2() As System.Windows.Forms.Button
    Public GroupBox1() As System.Windows.Forms.GroupBox
    Public RadioButton1() As System.Windows.Forms.RadioButton
    Public ListBox1 As System.Windows.Forms.ListBox

    Public ArrayList1 As New System.Collections.ArrayList     '手順記入用のアライリスト
    Public ArrayListG(180) As System.Collections.ArrayList    'Group(群)石記入用アライリスト
    Public G_Kosu As Integer = 0                              'Group(群)石記入用アライリストの数

    Public Okigo As Boolean = False                           '置碁であるか(置碁でない⇒False、置碁である⇒True)
    Public OkigoMoku As Integer = 0                           '何目の置碁か
    Public Kou As Boolean = False                             '劫であるかどうかの判定(劫でない⇒False、劫である⇒True)

    Public Ishi_Bango As Integer = 0                          '石の描画順番
    Public OrderName As String = ""                           '--開く--上書き保存--名前を付けて保存--削除--印刷--
    Public Hozon As Boolean = False                           '終了時に保存するかを確認する
    '                                                         (True⇒盤面に変化あり、保存するかを聞く、False⇒盤面変化なしか保存済、保存するかを聞かないで終了)
    Public MyfileName As String = ""                          '保存用ダイアグラムにのせるファイル名
    Public Start_Bango As Integer                             '印刷時の着手番号表示のスタート番号
    Public End_Bango As Integer                               '印刷時の着手番号表示の終了番号




#Region "◆石と手順番号を描画◆　　⇒　盤面に石を手順どおり描く"
    Public Sub 石と手順番号を描画(ByVal Grid As BoardGrid, ByVal Bango As Integer, ByVal Iro As String, ByVal X As Integer, ByVal Y As Integer)
        Dim Ishi As IshiStatus = New IshiStatus
        Ishi.Ishi_Status(Bango, Iro)                            '石の番号・色を決める
        Grid.Cells(X, Y).Status = Ishi.Cell_Status              '石を描く　
        PictureBox1.Invalidate()                                'PictureBox1_Paintのイベントを発生して再描画を要求する
        Label0(1).Text = Ishi.Label0Text

        Dim Groups As Group = New Group(Ishi.Number, Ishi.Iro, X, Y)
        If OrderName = "印刷" Then
            If Start_Bango >= Bango And Bango <= End_Bango Then
                Groups.Group_Form(Grid)                        '繋がった石でグループを作成し、ArrayListGに格納する
                Groups.Enclose_Ishi(Grid)                      '囲まれた石を抽出し、その石を消す
            End If
        Else
            Groups.Group_Form(Grid)
            Groups.Enclose_Ishi(Grid)
        End If

        Ishi_Bango = Bango
    End Sub
#End Region



#Region "◆石のクリヤー◆　　⇒　盤面の石を消去する"
    Public Sub 石のクリヤー(ByVal Grid As BoardGrid)
        '--------------------盤面のすべての石を消去する
        For X As Integer = 0 To 18
            For Y As Integer = 0 To 18
                If Grid.Cells(X, Y).Status <> CellStatus.Nothing Then
                    Grid.Cells(X, Y).Status = CellStatus.Nothing
                    PictureBox1.Invalidate()
                End If
            Next
        Next

        '------------------群アライリストのすべてのデータを消去する
        For i As Integer = 0 To G_Kosu - 1
            ArrayListG(i).Clear()
            ArrayListG(i).TrimToSize()
        Next
        G_Kosu = 0

    End Sub
#End Region



#Region "◆盤面の全クリアー◆ 　　⇒　起動時の初期状態に戻す"
    Public Sub 盤面の全クリアー(ByVal Grid As BoardGrid)
        Call 石のクリヤー(Grid)

        '------------------ArrayList1、Dのすべてのデータを消去する
        ArrayList1.Clear()
        ArrayList1.TrimToSize()

        '------------------諸元のリセット
        Ishi_Bango = 0
        Okigo = False
        OkigoMoku = 0
        Hozon = False

        PictureBox1.Enabled = True
        Button1(1).Enabled = False
        Item1(1).Enabled = True
        Item1(2).Enabled = False
        Item1(3).Enabled = False
        Item1(4).Enabled = True
        Item1(6).Enabled = True

        '------------------表示の変更
        Label0(0).Text = " 囲 碁 対 局 棋 譜 記 録 "
        Label0(1).Text = "互　　　　　戦"
        Label0(2).Text = "(互　　　戦)"
        Label0(3).Text = "★ 数字が赤色でアンダーラインのある石は、マウスの 「右ボタン」 クリックで 「取り消す」 ことが出来ます。"
        TextBox1(0).Text = Year(Now) - 1988               '年
        TextBox1(1).Text = Month(Now)                     '月
        TextBox1(2).Text = Microsoft.VisualBasic.Day(Now) '日
        TextBox1(3).Text = ""                             '白の対局者氏名
        TextBox1(4).Text = ""                             '黒の対局者氏名
        TextBox1(5).Text = ""                             '白の段位
        TextBox1(6).Text = ""                             '黒の段位
        ComboBox1(0).SelectedIndex = ComboBox1(0).FindString("段")
        ComboBox1(1).SelectedIndex = ComboBox1(1).FindString("段")

        '------------------チェックマークを非表示
        For i As Integer = 7 To 15
            Item1(i).Checked = False
        Next
        Item1(7).Checked = True

        TextBox1(3).Select()
    End Sub
#End Region



#Region "◆盤面の初期設定◆　　⇒　棋譜を選定した場合に最初に設定する"
    Public Sub 盤面の初期設定(ByVal Grid As BoardGrid, ByVal OpenFileDialog1 As OpenFileDialog)

        '▼テキストファイルからデータを読込みArrayList1に格納する
        Dim Reader As New IO.StreamReader(OpenFileDialog1.FileName, System.Text.Encoding.GetEncoding("Shift-JIS"))
        Dim Line As String = Reader.ReadLine                               'CSVの一行
        Do Until IsNothing(Line)
            ArrayList1.AddRange(Line.Replace("""", "").Split(CChar(",")))  '１行を,で区切られた項目ごとに分解し、分解した項目をArrayListに格納
            Line = Reader.ReadLine                                         '次の行を読み込む。
        Loop
        Reader.Close()


        '▼画面をテキストファイルのデータ通り初期表示する
        MyfileName = ArrayList1.Item(1)
        Label0(0).Text = " " & System.IO.Path.GetFileNameWithoutExtension(OpenFileDialog1.FileName) & " "
        Label0(1).Text = "互　　　　　戦"
        Label0(2).Text = "(互　　　戦)"
        Label0(3).Text = "★ 数字が赤色でアンダーラインのある石は、マウスの 「右ボタン」 クリックで 「取り消す」 ことが出来ます。"
        TextBox1(0).Text = ArrayList1.Item(5)   '年
        TextBox1(1).Text = ArrayList1.Item(6)   '月
        TextBox1(2).Text = ArrayList1.Item(7)   '日

        TextBox1(3).Text = ArrayList1.Item(9)   '白　対局者名
        TextBox1(5).Text = ArrayList1.Item(10)  '白　段位または級位
        ComboBox1(0).Text = ArrayList1.Item(11) '白　段又は級
        TextBox1(4).Text = ArrayList1.Item(13)  '黒　対局者名
        TextBox1(6).Text = ArrayList1.Item(14)  '黒　段位または級位
        ComboBox1(1).Text = ArrayList1.Item(15) '黒　段又は級

        '▼置碁の場合は石を置き直す
        If ArrayList1.Item(2) = True Then
            Okigo = True
            OkigoMoku = CInt(ArrayList1.Item(3))

            Dim Hdc As Handicap = New Handicap(OkigoMoku)
            Hdc.Mokusu(Grid)

            Label0(1).Text = "この碁は 「" & Hdc.MyLabel1 & " 」です。"
            Label0(2).Text = Hdc.MyLabel2
            Item1(8).Checked = False
            Item1(CInt(ArrayList1.Item(3)) + 7).Checked = True
        End If

        '▼ArrayList1から表示したものを削除する(石の記録以外のもの)
        ArrayList1.RemoveRange(0, 16)
        ArrayList1.TrimToSize()


        PictureBox1.Select()
    End Sub
#End Region



#Region "◆サウンドを演奏◆"
    Public Onsei1 As String = FPath & "My Data\711SYNTH002.wav" '擬音
    Public Const SND_ASYNC As Integer = &H1                     '非同期でサウンド再生

    'サウンドデータを演奏する
    <System.Runtime.InteropServices.DllImport("winmm.dll", EntryPoint:="PlaySound")> Public Function PlaySound(<System.Runtime.InteropServices.MarshalAs _
                                             (System.Runtime.InteropServices.UnmanagedType.LPStr)> ByVal pszSound As String, ByVal hModule As Integer, _
                                              ByVal dwFlags As Integer) As Integer
    End Function
#End Region



End Module
